searchData={"items":[{"type":"module","title":"PhoenixPandoc","doc":"A Phoenix template engine for [pandoc](https://github.com/jgm/pandoc) that\nfully supports EEx templates.\n\nIt tries (not very hard) to map file extensions to pandoc readers, but any\nreader can be used by naming the template like `name.html.reader`. See\n`pandoc --list-input-formats` for a list of supported readers.","ref":"PhoenixPandoc.html"},{"type":"module","title":"Optional Markdown Configuration - PhoenixPandoc","doc":"Pandoc supports multiple flavors of Markdown. This module defaults to the\nGithub-flavored Markdown reader (`gfm`) for `.md` files. This can be\noverridden in your project's `config.exs` like so:\n\n```elixir\n  config :phoenix_pandoc, markdown_flavor: \"commonmark\"\n```\n\n`:markdown_flavor` must be set to one of: `[\"gfm\", \"commonmark\", \"markdown\", \"markdown_phpextra\", \"markdown_strict\"]`.","ref":"PhoenixPandoc.html#module-optional-markdown-configuration"},{"type":"function","title":"PhoenixPandoc.extension_to_reader!/1","doc":"Try to detect the pandoc reader for a file extension.\n\nSupports the following extension mappings:\n\n| Extension | Reader |\n| :-: | :-: |\n|.eex|html|\n|.html|html|\n|.md|gfm|\n|.mmd|markdown_mmd|\n|.tex|latex|\n\n\nThis function raises an `ArgumentError` if the extension is not explicitly\nsupported, or a pandoc reader.","ref":"PhoenixPandoc.html#extension_to_reader!/1"},{"type":"module","title":"PhoenixPandoc.Engine","doc":"Implementation of the `Phoenix.Template.Engine` behaviour.\n\nThis module invokes pandoc via the `PhoenixPandoc.Pandoc` wrapper at runtime.\nThe templates cannot be converted at compile time since they must be\nevaluated by EEx first (tags may generate markup), and the `assigns` are not\navailable then. It relies on `Phoenix.HTML.Engine` to sanitize the HTML.","ref":"PhoenixPandoc.Engine.html"},{"type":"function","title":"PhoenixPandoc.Engine.compile/2","doc":"Implementation of the `c:Phoenix.Template.Engine.compile/2` callback\n\nThis is invoked by `Phoenix.Template`\n[here](https://github.com/phoenixframework/phoenix/blob/fb2a3f26a49d6f9fdee7e2d03c71ae3fe0d3333c/lib/phoenix/template.ex#L349).\nIt is used to compile the template into a function. You should never need to\ncall this directly.\n\nPandoc will be invoked at runtime if the input template contains any EEx tags.","ref":"PhoenixPandoc.Engine.html#compile/2"},{"type":"function","title":"Parameters - PhoenixPandoc.Engine.compile/2","doc":"* `path` - Path of the temlate being compiled\n* `_name` - Name of the template being compiled, stripped of its suffix.\n\nThe second callback parameter is ignored. It could be used to control the\npandoc writer, but Phoenix requires HTML.","ref":"PhoenixPandoc.Engine.html#compile/2-parameters"},{"type":"module","title":"PhoenixPandoc.Pandoc","doc":"A thin wrapper around the pandoc executable.\n\nPandoc must be installed on your system for this module to work.","ref":"PhoenixPandoc.Pandoc.html"},{"type":"function","title":"PhoenixPandoc.Pandoc.convert/3","doc":"Convert a string between markup formats using pandoc.","ref":"PhoenixPandoc.Pandoc.html#convert/3"},{"type":"function","title":"Parameters - PhoenixPandoc.Pandoc.convert/3","doc":"* `input` - The string to convert with pandoc\n* `from` - The pandoc reader to parse `input` with\n* `to` - The pandoc writer for the output\n\nWhen `from` and `to` are the same, the input is returned unmodified.","ref":"PhoenixPandoc.Pandoc.html#convert/3-parameters"},{"type":"function","title":"PhoenixPandoc.Pandoc.readers/0","doc":"List of readers supported by pandoc.","ref":"PhoenixPandoc.Pandoc.html#readers/0"},{"type":"function","title":"PhoenixPandoc.Pandoc.writers/0","doc":"List of writers supported by pandoc.","ref":"PhoenixPandoc.Pandoc.html#writers/0"},{"type":"extras","title":"Phoenix Template Engine for Pandoc","doc":"# Phoenix Template Engine for Pandoc\n\nA Phoenix template engine that uses [pandoc][0] to convert templates to HTML.\nIt fully supports EEx tags as well as all input formats supported by pandoc.","ref":"readme.html"},{"type":"extras","title":"Installation - Phoenix Template Engine for Pandoc","doc":"You must first [install pandoc][1] on the system you intend to run Phoenix on.\n\nThe package can be installed by adding `phoenix_pandoc` to the list of dependencies in your `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    {:phoenix_pandoc, \"~> 1.0\"},\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Phoenix Template Engine for Pandoc","doc":"To use this template engine with Phoenix, you have to configure it for each\nfile extension you want to use. Add lines to your `config.exs` similar to:\n\n```elixir\nconfig :phoenix, :template_engines,\n  md: PhoenixPandoc.Engine,\n  rst: PhoenixPandoc.Engine\n```\n\nTo enable live reloading for those extensions, you need to edit the patterns\nthat `phoenix_live_reload` watches. For the above example, your\n`config/dev.exs` might look like:\n\n```elixir\nconfig :my_app, MyApp.Endpoint,\n  live_reload: [\n    patterns: [\n      ~r{priv/static/.*(js|css|png|jpeg|jpg|gif|svg)$},\n      ~r{lib/my_app_web/views/.*(ex)$},\n      ~r{lib/my_app_web/templates/.*(eex|md|rst)$}\n    ]\n  ]\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Optional Markdown Configuration - Phoenix Template Engine for Pandoc","doc":"Pandoc supports a number of markdown flavors. See the `PhoenixPandoc` module\nfor details on how to configure the default flavor.\n\n[0]: https://github.com/jgm/pandoc\n[1]: https://pandoc.org/installing.html","ref":"readme.html#optional-markdown-configuration"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}